-- If you aren't a shaman, then disable the addon
if select(2, UnitClass("player")) ~= "SHAMAN" then
	return
end


local f = CreateFrame("frame")
local max_resources = 6
local xpos = 0
local ypos = 0
local r = 0.0
local g = 0.44
local b = 0.87
local scale = 1
local hidenocombat = false
local leftanchor = "CENTER"
local ssrframes = {}
local duetohide = false
local firstrun = true
local is_hidden = true
local has_initialized = false

local maelstrom_name = "Maelstrom Weapon"
local fulmination_name = "Lightning Shield"


f:SetScript("OnEvent", function(self, event, ...)
    self[event](self, ...)
end)

local function getCharges()
	local _, _, _, count1 =  UnitAura("player", maelstrom_name)

	if count1 == nil then
		count1 = 0
	end

	local _, _, _, count2 =  UnitAura("player", fulmination_name)

	if count2 == nil then
		count2 = 0
	end
	count2 = count2-1
	if count2 < 0 then count2 = 0 end

	if count1 > count2 then
		return count1
	end

	return count2

end

local function updateResources()
	local power = getCharges()
	local i = 1

	while i <= power do
		ssrframes[i]:SetBackdropColor(r, g, b, 1)
		i = 1 + i
	end

	while i <= max_resources do
		ssrframes[i]:SetBackdropColor(r, g, b, 0.1)
		i = 1 + i
	end

	if duetohide and power == 0 then
		for i = 1,max_resources do
			ssrframes[i]:Hide()
		end
		duetohide = false
		is_hidden = true
	end

end


local function updateFrames()
	for i = 1,max_resources do

		ssrframes[i]:SetSize(22, 22)

		ssrframes[i]:SetBackdropColor(r, g, b, 0.1)
		ssrframes[i]:SetBackdropBorderColor(0, 0, 0, 1)
	 
		if i == 1 then
			ssrframes[i]:SetPoint(leftanchor, UIParent, leftanchor, xpos, ypos)
			ssrframes[i]:SetScale(scale)

			ssrframes[i]:SetMovable(true)
			ssrframes[i]:EnableMouse(true)
			ssrframes[i]:RegisterForDrag("LeftButton")
			ssrframes[i]:SetScript("OnDragStart", function(self)
				if IsAltKeyDown() then
					self:StartMoving()
				end
			end)
			ssrframes[i]:SetScript("OnDragStop", function(self)
				self:StopMovingOrSizing()
				anch,_, _, x, y = self:GetPoint(1)
				xpos = x
				SimpleShamanResourcesDB.xpos = x
				xpos = y
				SimpleShamanResourcesDB.ypos = y
				leftanchor = anch
				SimpleShamanResourcesDB.leftanchor = anch

			end)
			

		else
			ssrframes[i]:SetPoint("RIGHT", 23, 0)

		end

		if hidenocombat and not InCombatLockdown() then
			duetohide = true
		else
			ssrframes[i]:Show()
			is_hidden = false
		end
		

	end
	updateResources()
end

local function initFrames()
	for i = 1,max_resources do
		ssrframes[i] = CreateFrame("Frame", "SSRFrame"..i, i == 1 and UIParent or ssrframes[i-1])
		ssrframes[i]:SetBackdrop({bgFile=[[Interface\ChatFrame\ChatFrameBackground]],edgeFile=[[Interface/Tooltips/UI-Tooltip-Border]],tile=true,tileSize=4,edgeSize=4,insets={left=0.5,right=0.5,top=0.5,bottom=0.5}})
	end
	updateFrames()
	has_initialized = true
end

local function destroyFrames()
	for i = 1,max_resources do
		if ssrframes[i] ~= nil then
			ssrframes[i]:Hide()
		end
	end
	for i = 1,max_resources do
		if ssrframes[i] ~= nil then
			ssrframes[i] = nil
		end
	end
	ssrframes = {}
end

local function updateNumBoxes()
	if has_initialized == false then
		return
	end

	local old_max_resources = max_resources
	
	
	local specId = 0
	local tmp_spec = GetSpecialization()
	if tmp_spec ~= nil then
		specId = GetSpecializationInfo(tmp_spec)
	end

		
	if specId == 263 then
		max_resources = 5
	elseif specId == 262 then
		max_resources = 6
	else 
		max_resources = 0
	end

	if old_max_resources == 6 and max_resources == 5 then
		if ssrframes[6] ~= nil then
			ssrframes[6]:Hide()
		end
	elseif old_max_resources == 5 and max_resources == 6 then
		if ssrframes[6] ~= nil then
			ssrframes[6]:Show()
		else
			ssrframes[6] = CreateFrame("Frame", "SSRFrame6", ssrframes[5])
			ssrframes[6]:SetBackdrop({bgFile=[[Interface\ChatFrame\ChatFrameBackground]],edgeFile=[[Interface/Tooltips/UI-Tooltip-Border]],tile=true,tileSize=4,edgeSize=4,insets={left=0.5,right=0.5,top=0.5,bottom=0.5}})
			ssrframes[6]:SetSize(22, 22)
			ssrframes[6]:SetBackdropColor(r, g, b, 0.1)
			ssrframes[6]:SetBackdropBorderColor(0, 0, 0, 1)
			ssrframes[6]:SetPoint("RIGHT", 23, 0)
			if is_hidden then
				ssrframes[6]:Hide()
			else
				ssrframes[6]:Show()
			end


			updateResources()
		end
	elseif max_resources == 0 then
		for i = 1,old_max_resources do
			if ssrframes[i] ~= nil then
				ssrframes[i]:Hide()
			end
		end
		is_hidden = true
	elseif old_max_resources ~= max_resources then
		if ssrframes[1] ~= nil then
			destroyFrames()
			initFrames()
		else
			initFrames()
		end
		is_hidden = false
	end
end

function SSR_ColorPickCallback(restore)
	if restore then
		r, g, b = unpack(restore)
	else
		r, g, b = ColorPickerFrame:GetColorRGB();
	end
	
	SimpleShamanResourcesiDB.r = r
	SimpleShamanResourcesDB.g = g
	SimpleShamanResourcesDB.b = b

	updateFrames()
end

function f:PLAYER_ENTERING_WORLD()
	updateResources()
end

function f:PLAYER_LOGIN()
	-- 263 = enha
	-- 262 = ele

	local specId = 0
	local tmp_spec = GetSpecialization()
	if tmp_spec ~= nil then
		specId = GetSpecializationInfo(tmp_spec)
	end

	if specId == 263 then
		max_resources = 5
	elseif specId == 262 then
		max_resources = 6
	else 
		max_resources = 0
	end

	local locale = GetLocale()
	if locale == "ruRU" then
		maelstrom_name = "Оружие Водоворота"
		fulmination_name = "Щит молний"
	elseif locale == "deDE" then
		maelstrom_name = "Waffe des Mahlstroms"
		fulmination_name = "Blitzschlagschild"
	elseif locale == "esES" or locale == "esMX" then
		maelstrom_name = "Arma vorágine"
		fulmination_name = "Escudo de relámpagos"
	elseif locale == "ptBR" then
		maelstrom_name = "Arma da Voragem"
		fulmination_name = "Escudo de Raios"
	elseif locale == "frFR" then
		maelstrom_name = "Arme du Maelström"
		fulmination_name = "Bouclier de foudre"
	else
		maelstrom_name = "Maelstrom Weapon"
		fulmination_name = "Lightning Shield"
	end

	initFrames()
end

function f:UNIT_AURA(unit)
	if unit == "player" then
		if firstrun then
			updateNumBoxes()
			firstrun = false
		end
		updateResources()
	end
end

function f:PLAYER_TALENT_UPDATE()
	updateNumBoxes()
end
	
function f:PLAYER_REGEN_DISABLED()
	updateNumBoxes()
	for i = 1,max_resources do
		ssrframes[i]:Show()
	end
	is_hidden =  false
	duetohide = false
end

function f:PLAYER_REGEN_ENABLED()
	if hidenocombat then
		if getCharges() == 0 then
			for i = 1,max_resources do
				ssrframes[i]:Hide()
			end
			is_hidden = true
		else
			duetohide = true
		end
	end
end


function f:ADDON_LOADED(addon)
	if addon ~= "SimpleShamanResources" then return end
	if select(2, UnitClass("player")) ~= "SHAMAN" then
		return
	end

	local defaults = {
		xpos = 0,
		ypos = 0,
		r = 0.0,
		g = 0.44,
		b = 0.87,
		scale = 1,
		leftanchor = "CENTER",
		hidenocombat = false
	}
		
	SimpleShamanResourcesDB = SimpleShamanResourcesDB or {}
		
	for k,v in pairs(defaults) do
		if SimpleShamanResourcesDB[k] == nil then
			SimpleShamanResourcesDB[k] = v
		end
	end


	SLASH_SSR1, SLASH_SSR2 = "/ssr", "/simpleshamanresources"
	SlashCmdList.SSR = function(txt)
		local cmd, msg = txt:match("^(%S*)%s*(.-)$");
		cmd = string.lower(cmd)
		msg = string.lower(msg)

		if cmd == "reset" then
			xpos = 0
			ypos = 0
			r = 0.0
			g = 0.44
			b = 0.87
			scale = 1
			leftanchor = "CENTER"
			SimpleShamanResourcesDB.xpos = 0
			SimpleShamanResourcesDB.ypos = 0
			SimpleShamanResourcesDB.r = 0.0
			SimpleShamanResourcesDB.g = 0.44
			SimpleShamanResourcesDB.b = 0.87
			SimpleShamanResourcesDB.scale = 1
			SimpleShamanResourcesDB.leftanchor = "CENTER"
			
			destroyFrames()
			initFrames()

			print("Frame reset to the center, you can now move it to the desired position.")

		elseif cmd == "scale" then
			local num = tonumber(msg)
			if num then
				scale = num
				SimpleShamanResourcesDB.scale = num

				updateFrames()
			else
				print("Not a valid scale! Scale has to be a number, recommended to be between 0.5 and 3")
			end
		elseif cmd == "color" or cmd == "colour" then
			ColorPickerFrame:SetColorRGB(r,g,b)
			ColorPickerFrame.previousValues = {r,g,b}
			ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = SSR_ColorPickCallback, SSR_ColorPickCallback, SSR_ColorPickCallback
			ColorPickerFrame:Hide() -- apparently needed...
			ColorPickerFrame:Show()
		elseif cmd  == "nocombat" then
			if msg == "on" then
				hidenocombat = false
				SimpleShamanResourcesDB.hidenocombat = false
				duetohide = false
				f:UnregisterEvent("PLAYER_REGEN_ENABLED")
				f:UnregisterEvent("PLAYER_REGEN_DISABLED")
				for i = 1,max_resources do
					ssrframes[i]:Show()
				end
			elseif msg == "off" then
				hidenocombat = true
				SimpleShamanResourcesDB.hidenocombat = true
				f:RegisterEvent("PLAYER_REGEN_ENABLED")
				f:RegisterEvent("PLAYER_REGEN_DISABLED")

				if not InCombatLockdown() then
					for i = 1,max_resources do
						ssrframes[i]:Hide()
					end
					is_hidden = true
				end

			else
				print("|cffff0000Invalid command!|r Use |cff3399FF/ssr nocombat off|r or |cff3399FF/ssr nocombat on|r")
			end

		else
			print("|cff3399FF/ssr|r usage:")
			print("|cff3399FF/ssr reset|r Resets the addon back to default settings. Use if you can't see the frame and/or dragged it out of the screen.")
			print("|cff3399FF/ssr color|r Open the color picker window.")
			print("|cff3399FF/ssr scale|r Change the scale of the addon (default: 1, don't use values larger than 3)")
			print("|cff3399FF/ssr nocombat|r |cff00cf00on|r | |cffff0000off|r Whether the boxes should be shown outside combat or not.")
			print("|cff33FF99To move the boxes:|r Alt+Left mouse button on the leftmost box to drag it.")
		end

	end

	xpos = SimpleShamanResourcesDB.xpos
	ypos = SimpleShamanResourcesDB.ypos
	r = SimpleShamanResourcesDB.r
	g = SimpleShamanResourcesDB.g
	b = SimpleShamanResourcesDB.b
	scale = SimpleShamanResourcesDB.scale
	leftanchor = SimpleShamanResourcesDB.leftanchor
	hidenocombat = SimpleShamanResourcesDB.hidenocombat


	if hidenocombat and not InCombatLockdown() then
		duetohide = true
	end

	


	f:RegisterEvent("PLAYER_LOGIN")
	f:RegisterEvent("UNIT_AURA")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:RegisterEvent("PLAYER_TALENT_UPDATE")
	f:RegisterEvent("PLAYER_REGEN_DISABLED")

	if hidenocombat then
		f:RegisterEvent("PLAYER_REGEN_ENABLED")
	end




end

f:RegisterEvent("ADDON_LOADED")

